#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define LINELEN 128
#define DFLT_WORDS 1000
#define DFLT_LEN 20
#define streq(x,y) !strcmp(x,y)
#define instr(x,y) (int) (strchr(x,y)-x)

char words[DFLT_WORDS][DFLT_LEN];
FILE *filein;
FILE *fileout;
int num_words=0;
int num_kwestions=0;
char nullstr[2]="\0";

int mapword(char *word)
{
   int i=0,j=-1;
   while (j==-1 && i<num_words)
   {
      if (streq(word,words[i++])) j=i;
   }

   if (j!=-1) return j-1;

   strcpy(words[num_words++],word);
   return num_words-1;
}

char *left(char *string,int num)
{
   char temp[LINELEN]="\0";
   if (num>strlen(string) || num<=0) return string;
   strncat(temp,string,num);
   return temp;
}

char *rest(char *string,int num)
{
   if (num>strlen(string) || num<=0) return nullstr;
   return string+num;
}

char *removes(char *string)
{
   char *temp=string;
   strcpy(temp,string);
   while (*temp==' ' && temp<strlen(string)+string) temp++;
   if (temp>=strlen(string)+string) temp=nullstr;
   return temp;
}

char *tonums(char *string)
{
   char first[LINELEN],answer[LINELEN],scrap[10];
   int i;
   strcpy(answer,"\0");
   while(strlen(string)>0)
   {
      i=instr(string,' ');
      strcpy(first,left(string,i));
      strcpy(string,removes(rest(string,i+1)));
      sprintf(scrap,"%d",mapword(first));
      strcat(answer,scrap);
      strcat(answer," ");
   }
   return answer;
}


int main(int argc,char **argv)
{
   char string[256];
   int wrotekw=0,i;

   if (argc!=3)
   {
      printf("Syntax: %s <infile> <outfile>\n",argv[0]);
      return 0;
   }

   if ((filein=fopen(argv[1],"r"))==NULL)
   {
      printf("%s: Cannot open input file\n",argv[0]);
      return 0;
   }

   if ((fileout=fopen(argv[2],"w"))==NULL)
   {
      printf("%s: Cannot open output file\n",argv[0]);
      fclose(filein);
      return 0;
   }

   /* scan for questions */
   while (!feof(filein))
   {
      fscanf(filein,"%[^\n]\n",string);
      if (string[0]=='?')
      {
         num_kwestions++;
         fscanf(filein,"%[^\n]\n",string);
         fscanf(filein,"%[^\n]\n",string);
         fscanf(filein,"%[^\n]\n",string);
      }
   }

   /* right now parse the file */
   rewind(filein);
   while (!feof(filein))
   {
      fscanf(filein,"%[^\n]\n",string);
      switch(string[0])
      {
         case '#' :
            /* directive so include it */
            fprintf(fileout,"%s\n",string);
            break;

         case '?' :
            if (!wrotekw)
            {
               fprintf(fileout,"\n#questions %d\n\n",num_kwestions);
               wrotekw=1;
            }
            fprintf(fileout,"%s\n",string);
            for (i=0;i<3;i++)
            {
               fscanf(filein,"%[^\n]\n",string);
               fprintf(fileout,"  %s\n",tonums(string));
            }
            fprintf(fileout,"\n");
            break;

	 default :
	    printf("Cannot understand field; ignoring...\n");
	    break;
      }
   }

   /* write the words */
   fprintf(fileout,"\n#words %d\n\n",num_words);
   for (i=0; i<num_words; i++)
   {
      fprintf(fileout,"%d %s\n",i,words[i]);
   }

   /* finish successful: close all files now */
   fclose(filein);
   fclose(fileout);
   return 1;
}
